/* Pavel Surynek, 2008 */
/* pavel.surynek@mff.cuni.cz */
/* mit_main.cpp */

/*
  An implementation of the algorithm for solving sliding box puzzles by
  Kornhauser, Miler, and Spirakis.
 */

#include "slider.h"
#include "mit.h"
#include "tbox.h"


SLIDER slider1, slider2, slider3;
SOLUTION_DATABASE database;


int main(int UNUSED(argc), char **UNUSED(argv))
{
	clock_t begin, end;

//	generate_solution_database_Revised("solution_database_revised_trans");
	generate_solution_3_database_Revised("solution_database_revised_3_cycle");

//	init_slider(0, 7, 5, 10, &slider1);
/*
	database.load("solution_database_A.txt");

	for (int l = 0; l < 100; ++l)
	{
		FINE_SOLUTION solution, mit_solution;

		begin = clock();

		init_slider(0, 7, 5, 10, &slider1);

		for (int i = 0; i < slider1.m_V * slider1.m_V; ++i)
		{
			int pos1 = rand() % (slider1.m_V - 1) + 1;
			int pos2 = (pos1 + 1) % (slider1.m_V - 1) + 1;

			swap_goal(pos1, pos2, &slider1);
		}

		copy_slider(&slider1, &slider2);
		copy_slider(&slider1, &slider3);
		solve_slider_tbox(&slider1, database, solution, 10000.0);
		solve_slider_mit(&slider3, mit_solution);
	
		printf("TBOX solution length: %d\n", solution.size());
		printf(" MIT solution length: %d\n", mit_solution.size());
		printf("         Improvement: %.3f\n", (double)mit_solution.size() / (double)solution.size());

		print_slider(&slider2);
		execute_fine_solution(&slider2, solution);
		
		print_slider(&slider2);

		destroy_slider(&slider1);
		destroy_slider(&slider2);
		destroy_slider(&slider3);

		end = clock();
		printf("Time:%.3f\n", (end - begin) / (double)CLOCKS_PER_SEC);
	}

	database.save("solution_database_A.txt");
*/
	return 0;
}
